from abc import ABC, abstractmethod
from typing import Optional

from cpl_query.extension import List
from gismo_data.model.user_joined_voice_channel import UserJoinedVoiceChannel

class UserJoinedVoiceChannelRepositoryABC(ABC):

    @abstractmethod
    def __init__(self): pass
    
    @abstractmethod
    def get_user_joined_voice_channels(self) -> List[UserJoinedVoiceChannel]: pass
    
    @abstractmethod
    def get_user_joined_voice_channel_by_id(self, id: int) -> UserJoinedVoiceChannel: pass
    
    @abstractmethod
    def get_user_joined_voice_channels_by_user_id(self, user_id: int) -> list[UserJoinedVoiceChannel]: pass
    
    @abstractmethod
    def get_active_user_joined_voice_channel_by_user_id(self, user_id: int) -> UserJoinedVoiceChannel: pass
    
    @abstractmethod
    def find_active_user_joined_voice_channel_by_user_id(self, user_id: int) -> Optional[UserJoinedVoiceChannel]: pass

    @abstractmethod
    def find_active_user_joined_voice_channels_by_user_id(self, user_id: int) -> List[Optional[UserJoinedVoiceChannel]]: pass
    
    @abstractmethod
    def add_user_joined_voice_channel(self, user_joined_voice_channel: UserJoinedVoiceChannel): pass
    
    @abstractmethod
    def update_user_joined_voice_channel(self, user_joined_voice_channel: UserJoinedVoiceChannel): pass
    
    @abstractmethod
    def delete_user_joined_voice_channel(self, user_joined_voice_channel: UserJoinedVoiceChannel): pass
