from cpl_core.logging import LoggerABC
from discord.ext import commands
from discord.ext.commands import Context

from gismo_core.abc.bot_service_abc import BotServiceABC
from gismo_core.abc.client_utils_service_abc import ClientUtilsServiceABC
from gismo_core.abc.command_abc import CommandABC
from gismo_core.abc.message_service_abc import MessageServiceABC


class PingCommandService(CommandABC):

    def __init__(
            self,
            logger: LoggerABC,
            message_service: MessageServiceABC,
            bot: BotServiceABC,
            client_utils: ClientUtilsServiceABC
    ):
        CommandABC.__init__(self)

        self._logger = logger
        self._message_service = message_service
        self._bot = bot
        self._client_utils = client_utils

        self._logger.trace(__name__, f'Loaded command service: {type(self).__name__}')

    @commands.command()
    async def ping(self, ctx: Context):
        self._logger.debug(__name__, f'Received command ping {ctx}')
        self._client_utils.received_command(ctx.guild.id)
        await self._message_service.send_ctx_msg(ctx, 'Pong')
        self._logger.trace(__name__, f'Finished ping command')
