from datetime import datetime

from cpl_core.application.application_extension_abc import ApplicationExtensionABC
from cpl_core.configuration import ConfigurationABC
from cpl_core.dependency_injection import ServiceProviderABC
from cpl_core.logging import LoggerABC

from gismo_data.service.migration_service import MigrationService


class DatabaseExtension(ApplicationExtensionABC):

    def __init__(self):
        pass

    async def run(self, config: ConfigurationABC, services: ServiceProviderABC):
        logger: LoggerABC = services.get_service(LoggerABC)
        logger.debug(__name__, 'Database extension started')
        config.add_configuration('Database_StartTime', str(datetime.now()))
        migrations = services.get_service(MigrationService)
        migrations.migrate()
